function PickerDrawer(name, displaytext, savetext) {
    this.name = name;   // id of frame, and name of JS variable set to this instance.
    this.element = document.getElementById(name);
    this.displaytext = document.getElementById(displaytext);
    this.savetext = document.getElementById(savetext);
    this.single = false;
    this.windowTitle='Select links';
    this.batch_size=100;
    
    this.initialize = function(editor, drawertool) {
        this.editor = editor;
        this.drawertool = drawertool;
    };

    this.addReference = function(uid, title) {
        // Add the specified reference to the list of references.
        if (this.single) {
            this.removeAllReferences();
        }
        var el = document.createElement("div");
        var remove = document.createElement("a");
        var delimage = document.createElement("img");
        delimage.src = "delete_icon.gif";
        remove.appendChild(delimage);
        remove.href = "#";
        var handler=this;
        removeit = function() {
            handler.removeReference(uid);
            return false;
        };
        remove.onclick = removeit;
        el.appendChild(remove);
        el.appendChild(document.createTextNode('\u00a0'));
        el.appendChild(document.createTextNode(title));
        el.id = uid;
        this.displaytext.appendChild(el);

        if (this.single) {
            this.button.value = 'open popup';
            this.savetext.value = uid;
            this.hide();
        } else {
            var save = this.savetext.value.split(/\r?\n/);
            save.push(uid);
            this.savetext.value = save.join('\n');
        }
    };

    this.removeAllReferences = function() {
        var divs = this.displaytext.childNodes;
        for (var i = divs.length-1; i >= 0; i--) {
            if (divs[i].nodeType==1) {
                this.displaytext.removeChild(divs[i]);
            }
        }
        this.savetext.value = '';
    }
    
    this.removeReference = function(uid) {
        var divs = this.displaytext.childNodes;
        var save = new Array();
        for (var i = divs.length-1; i >= 0; i--) {
            if (divs[i].nodeType==1) {
                var UID = divs[i].id;
                if (UID==uid) {
                    this.displaytext.removeChild(divs[i]);
                } else {
                    save.push(UID);
                }
            }
        }
        save.reverse();
        this.savetext.value = save.join('\n');
    };

    this.getUids = function(frameDoc) {
        // Set/clear check boxes to match the currently selected items.
        var uids = this.savetext.value.split(/\r?\n/);
        return uids;
    }

    this.pageHeight = function() {
        return Math.max(document.body.scrollHeight, document.body.offsetHeight);
        
        var x,y;
        var test1 = document.body.scrollHeight;
        var test2 = document.body.offsetHeight
        if (test1 > test2) // all but Explorer Mac
        {
            x = document.body.scrollWidth;
            y = document.body.scrollHeight;
        } else // Explorer Mac;
                //would also work in Explorer 6 Strict, Mozilla and Safari
        {
            x = document.body.offsetWidth;
            y = document.body.offsetHeight;
        }
        return y;
    }
    this.verticalScroll = function() {
        if (self.pageYOffset) // all except Explorer
        {
            return self.pageYOffset;
        }
        else if (document.documentElement && document.documentElement.scrollTop)
        // Explorer 6 Strict
        {
            return document.documentElement.scrollTop;
        }
        else if (document.body) // all other Explorers
        {
            return document.body.scrollTop;
        }
    }
    
    this.Open = function(button) {
        this.button = button

        // Make the open button toggle the display so we have a way to
        // hide the popup.
        if (this.element.style.display == 'block') {
            this.element.style.display = 'none';
            button.value = 'open popup'
        } else {
            this.createContent();
            this.element.left = 0;
            this.element.top = -this.element.offsetHeight;
            button.value = 'close popup'
        }
        return false;
    }

    this.createContent = function() {
        /* fill the drawer with some content */
        var e = this.element;
        var w = e.contentWindow;

        var types = '';
        var title = '';
        var batch = '';
        var location = '';
        var basesearch = '';
        var query_first = '';
        if (this.allowed_types.length > 0) {
            var sep = '&type:list=';
            types = sep + this.allowed_types.join(sep);
        }

        batch = '&batch_size:int='+encodeURI(this.batch_size);
        if (this.query_first.length >0 ) {
            query_first = '&query_first:string='+encodeURI(this.query_first);
        }
        if (this.init_location.length > 0) {
            location = '&init_location:string='+encodeURI(this.init_location);
        }
        if (this.base_search.length > 0) {
            basesearch = '&base_search:string='+encodeURI(this.base_search);
        }

        if (this.windowTitle) {
            title = "&title:string="+encodeURI(this.windowTitle);
        }
        w.location = this.base + '/reference_picker?handler='+this.name+types+title+batch+query_first+location+basesearch;
        try { w.setChecks(); } catch(e) { };
        try { e.style.display = 'block'; } catch(e) {};
        try { w.focus(); } catch(e) {};
    };

    this.getDoc = function() {
        if (this.element.document) {
            return this.element.contentWindow.document; // IE
        } else {
            return this.element.contentDocument; // Mozilla
        }
    }
    this.hide = function() {
        this.element.style.display = 'none';
    };
    
};

var current_drawer = null;
function tree_Open(id) {
        /* open a drawer */
    if (current_drawer) {
        closeDrawer();
    };
    var drawer = this.drawers[id];
    drawer.createContent();
    this.current_drawer = drawer;
}
